# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.1
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.base_metric_response import BaseMetricResponse
from humanloop.type.config_response import ConfigResponse
from humanloop.type.config_type import ConfigType
from humanloop.type.evaluator_arguments_type import EvaluatorArgumentsType
from humanloop.type.evaluator_response import EvaluatorResponse
from humanloop.type.evaluator_return_type_enum import EvaluatorReturnTypeEnum
from humanloop.type.experiment_config_response import ExperimentConfigResponse
from humanloop.type.experiment_response import ExperimentResponse
from humanloop.type.experiment_status import ExperimentStatus
from humanloop.type.feedback_types import FeedbackTypes
from humanloop.type.model_config_evaluator_aggregate_response import ModelConfigEvaluatorAggregateResponse
from humanloop.type.positive_label import PositiveLabel
from humanloop.type.project_config_response import ProjectConfigResponse
from humanloop.type.project_model_config_feedback_stats_response import ProjectModelConfigFeedbackStatsResponse
from humanloop.type.project_response import ProjectResponse
from humanloop.type.project_user_response import ProjectUserResponse

class RequiredPaginatedDataProjectResponse(TypedDict):
    records: typing.List[ProjectResponse]

    page: int

    size: int

    total: int

class OptionalPaginatedDataProjectResponse(TypedDict, total=False):
    pass

class PaginatedDataProjectResponse(RequiredPaginatedDataProjectResponse, OptionalPaginatedDataProjectResponse):
    pass
